from flask import Flask, send_file
import requests
import os.path
import hashlib
import time

PAD_SERVER = 'https://pad.constantvzw.org'

CACHE_TIME = 10

CACHE_FOLDER = 'cache'

app = Flask(__name__)

def hash_slug (slug):
  return hashlib.sha256(slug.encode()).hexdigest() 

# /
@app.route('/p/<string:slug>')
def get_pad (slug):
  hash = hash_slug(slug)
  cache_path = os.path.join(CACHE_FOLDER, hash)
  now = time.time()
  
  if not os.path.exists(cache_path) or now - os.path.getmtime(cache_path) > CACHE_TIME:
    r = requests.get(os.path.join(PAD_SERVER, 'p', slug, 'export', 'txt'))

    with open(cache_path, 'w') as h:
      h.write(r.content.decode())

  return send_file(open(cache_path, 'rb'), 'text/plain')